{program rxSerialChallenger2
second version of this program, in pasm for fast transmission even with 5MHz clock.
sends serial strings at selected baud rate for testing the program rxSerial
This is in pasm, and the bytes to send are fetched from cog ram,
so there is very little extra beyond one stop bit, even when this is run with a 5MHz clkfreq and 115200 baud.
This can also be run in a separate Prop, linked to the first.
}
CON
  _CLKMODE = XTAL1 + PLL16X
  _XINFREQ = 5_000_000

VAR
  long   stack[32], cog

OBJ


PUB fizzy
  start(1,115200,1000)
  pause(100)

PUB start(txpin,baud,ms)
    stop
    pause(100)
    txmask   := 1 << txpin                                ' these are in the DAT section loaded into cog
    bitticks := clkfreq / baud                            ' clock ticks per bit
    fdelay := clkfreq/1000 * ms                            ' wait between packets
    pause(100)
    cog := cognew(@txserial, 0) + 1

PUB stop

'' Stop serial driver - frees a cog

  if cog
    cogstop(cog~ - 1)

pri pause(ms)
  waitcnt(clkfreq/1000*ms+cnt)



DAT
                        org     0

txserial                or     outa, txmask                    ' this tx pin is high outuput (stop bits high)
                        or     dira, txmask


txdelay                 movs    bytes,#message0                 ' point to first character
                        mov     txcnt,fdelay                    ' wait...
                        add     txcnt,cnt
                        waitcnt txcnt,#0

bytes                   mov     txdata,0-0                      ' self-modifying, step thru array of chars (long aligned)
                        tjz     txdata, #txdelay   wz           ' until end of z-string
                        add     bytes, #1                       ' self-modify, point to next char

prepare                 or      txdata, #$100                   ' append stop bit
                        shl     txdata, #1                      ' prepend start bit (logic 0)
                        mov     txN, #10                        ' start + 8 data + stop
                        mov     txcnt, bitticks                 ' bit duration
                        add     txcnt, cnt                      '

txbits                  shr     txdata, #1              wc      ' bit to C
                        muxc    outa, txmask                    ' output to pin
                        waitcnt txcnt, bitticks                 ' bit time
                        djnz    txN, #txbits                    ' countdown bits
                        jmp     #bytes                          ' next byte

dummy                   long    0-0
txmask                  long    0-0                              ' mask for tx pin
bitticks                long    0-0                              ' ticks per bit
fdelay                  long    0-0                              ' delay between packets

message0 long "Use this time slot to send a packet of data at set baud to prop #2, which should receive it perfectly but with low current drain.",13,0,0,0
                        ' note that characters are long aligned, a waste, but this is just a untility demo.

txdata                  res     1                               ' byte to transmit
txN                     res     1                               ' count bits
txcnt                   res     1                               ' tx bit timer


